/**********************************************************
 * This software is provided subject to the following terms
 * and conditions, which you should read carefully before
 * using the software. Using this software indicates your
 * acceptance of these terms and conditions.  If you do not
 * agree with these terms and conditions, do not use the
 * software. 
 * 
 * Copyright (c) 2002, Agere Systems
 * All rights reserved. 
 * 
 * Redistribution and use in source or binary forms, with or
 * without modifications, are permitted provided that the
 * following conditions are met: 
 * 
 * o Redistributions of source code must retain the above
 *   copyright notice, this list of conditions and the
 *   following Disclaimer in comments in the code as well as
 *   in the documentation and/or other materials provided with
 *   the distribution.
 * o Redistributions in binary form must reproduce the above
 *   copyright notice, this list of conditions and the following
 *   Disclaimer in the documentation and/or other materials
 *   provided with the distribution.
 * o Neither the name of Agere Systems nor the names of the
 *   contributors may be used to endorse or promote products
 *   derived from this software without specific prior written
 *   permission. 
 * 
 * Disclaimer 
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, INFRINGEMENT AND THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. ANY USE, MODIFICATION OR DISTRIBUTION OF
 * THIS SOFTWARE IS SOLELY AT THE USER'S OWN RISK. IN NO EVENT SHALL
 * AGERE SYSTEMS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, INCLUDING, BUT NOT LIMITED
 * TO, CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 * 
 **********************************************************/

struct set {
  struct list *baseElements;  /* sorted list */
  struct list *sets;          /* sorted list */
  int size;                   /* combined size of baseElements and sets */
  struct list *lsets;
  struct list *lvals;         /* sorted list: managed by manageLvalList */
  struct set *lvalLvals;      /* a set containing the lvals of the lvals of this set */
  struct set *skip;           /* points to an equivalent node */
  int lastRecomputed;         /* info about what was recomputed and when */
  int lastRecomputed2;         /* info about what was recomputed and when */ 
  int onPath;                 /* used to determine node status during getElem */
};
#define LAST_RECOMPUTED(s) (s->lastRecomputed >> 1)
#define SET_LAST_RECOMPUTED(s, i) (s->lastRecomputed = (i<<1))
#define LAST_RECOMPUTED2(s) (s->lastRecomputed2 >> 1)
#define SET_LAST_RECOMPUTED2(s, i) (s->lastRecomputed2 = (i<<1))
#define LVAL_LVALS_RECOMPUTED(s) (s->lastRecomputed2 & 0x1)
#define SET_LVAL_LVALS_RECOMPUTED(s) (s->lastRecomputed2 |= 0x1)

int memberUpdate(struct variable *lval, struct set *set, int update);
int insertSet(struct set *from, struct set *to);
struct set *emptySet(void);
struct list *getElems(struct set *s);
struct list *getSets(struct set *s);
struct set *getElemElems(struct set *s);
int recoverSetIndex(struct set *s);
void gcLvalLists(void);   
void freeL(struct list *l);

#define member(elem, set) (memberUpdate(elem, set, 0))  /* returns 1 if member */
#define insertLval(elem, set) (!memberUpdate(elem, set, 1)) /* returns 1 if changed */
#define insertElem(elem, set) (!memberUpdate(elem, set, 1)) /* returns 1 if changed */
#define isEmptySet(x) ((!(x) || (!(x->size) && !(x->skip))))

#define disposeElemList(x) 
#define resizeBitSets(x,y) 

int setsCount(void);

#ifdef NDEBUG
#undef debug
#define debug(EX) ((void)0)

#else
#define debug(EX) EX
#endif

#ifdef NDEBUG
#undef debugdec
#define debugdec(EX) 

#else
#define debugdec(EX) EX
#endif

extern int currentIterationIndex;

extern struct list *todo; /* variables to be loaded after a call to getSets or getElemElems */
